<html>
<head>
<title>Generic block game help</title>
<link rel="stylesheet" href="gbg.css">
</head>
<body>
<div class="header"><img src="gfx/gbgtitle.png" alt="Generic block game"></div>
<table class="nav">
	<tr>
		<td><a href="general.html">General information</a></td>
		<td><a href="variationhelps.html">Included variations</a></td>
		<th><a href="variations.html">.var file reference</a></th>
	</tr>
</table>

<h2>Variations</h2>
<p>Variations are text files that contain game rules. They are stored in variations\ folder. Variations with .var extension are shown in loader's menu. Variations with other extensions can be loaded from within other variations. </p>
<h3>Creating new variations</h3>
<p>The easiest way to make a new variation is to modify one of the existing ones. So, the first step is to open variations/ folder, make a copy of an existing variation, rename it and open in text editor.</p>
<h2>Segments</h2>
<p>Variation text file consists of several segments. Segments begin with name of the segment, followed by opened square ( { ) bracket. Segment content begins in the next line. Segment ends with a line that contains only closed square bracket ( } ).</p>
<p>This is an example segment:</p>
<pre>
Title {
Tetromino factory
}
</pre>
<p>The interpretation of segments is quite rigid, so don't change upper/lower case or add any extra spaces in titles or within segments. You can however type any text in areas outside of segments.</p>
<h3>List of currently supported segments</h3>
<ul>
<li><a href="#segtitle">Title</a></li>
<li><a href="#segsettings">Settings</a></li>
<li><a href="#segplayfield">Playfield</a></li>
<li><a href="#seginput">Input</a></li>
<li><a href="#segcycle">Cycle</a></li>
<li><a href="#seggoals">Goals</a></li>
<li><a href="#seghelp">Help</a></li>
<li><a href="#segnext">Next</a></li>
<li><a href="#segtilesets">Tilesets</a></li>
</ul>

<h3 id="segtitle">Title</h3>
<pre>
Title {
Tetromino factory
}
</pre>
<p>Contains the title. One line only.</p>

<h3 id="segsettings">Settings</h3>
<pre>
Settings {
tiles:7
gravity
}
</pre>
<p>Contains one or more lines. Each line is a keyword, which turns on a special feature of the game.</p>
<p>In variation file, Settings should appear before <a href="#segtilesets">Tilesets</a></p>

<table>
	<tr>
		<th>keyword</th>
		<th>effect</th>
	</tr>
	<tr>
		<td>gravity</td>
		<td>Blocks will fall down. If absent, blocks can be moved in any direction, and must be placed with <img src="gfx/keyenter.png" alt="enter" title="enter">.</td>
	</tr>
	<tr>
		<td>wrap</td>
		<td>Small blocks can be wrapped around the edges of playfield.</td>
	</tr>
	<tr>
		<td>inputrotate</td>
		<td>Signifies that input blocks are meant to be rotated. Cycle is ignored in this case.</td>
	</tr>
	<tr>
		<td>tiles:<em>n</em></td>
		<td>This setting is mandatory. It indicates how many tiles will be loaded. When used with randominputs it indicates tiles to be used in shapes controlled by player, tiles with higher number can be used for walls, decorations, etc.</td>
	</tr>
	<tr>
		<td>randominputs</td>
		<td>Indicates that numbers in input shapes will be interpreted as random colors. See <a href="#seginput">Input</a> segment.</td>
	</tr>
	<tr>
		<td>randomgoals</td>
		<td>Indicates that numbers in goal shapes will be interpreted as random colors. See <a href="#seggoals">Goals</a> segment.</td>
	</tr>
</table>

<h3 id="segplayfield">Playfield</h3>
<pre>
Playfield {
!!!!!!!!
........
........
........
........
........
........
........
........
........
}
</pre>
<p>Playfield is consists of characters, mainly dots, placed in a rectangular formation. Playfield must be rectangular.</p>
<table>
	<tr>
		<th>valid characters</th>
		<th>meaning</th>
	</tr>
	<tr>
		<td>. <em>(dot) or</em> 0 <em>(zero)</em></td>
		<td>empty space, where blocks can pass</td>
	</tr>
	<tr>
		<td><em>numbers or letters</em></td>
		<td>various tiles, serving as obstacles. See <a href="#segtilesets">Tilesets</a> segment.</td>
	</tr>
	<tr>
		<td>!</td>
		<td>source</td>
	</tr>
	<tr>
		<td>@</td>
		<td>destination</td>
	</tr>
</table>
<h4>Source</h4>
<p>A playfield must have a source. Input shapes appear in source. A source must be large enough for input shapes to appear in it. If an input shape, selected at random, cannot fit inside a source, it is cycled (see <a href="#segcycle">Cycle</a>). If neither of cycled shapes can fit, the game is over.
<h4>Destination</h4>
Destination is not mandatory. If playfield has destination tiles, and all destination tiles are covered with player-controlled shapes, the next variation is loaded (see <a href="#segnext">Next</a>).


<h3 id="seginput">Input</h3>
<pre>
Input {
1

2

3

4

5

6

7
}
</pre>
(In this example, input shapes are all single blocks of different colors.)
<p>Inputs segment contains definitions of several input shapes. The definitions are separated with empty line. The definitions must be of rectangular shape, empty space filled with dots (as in <a href="#segplayfield">Playfield</a> and <a href="#seggoals">Goals</a>)</p>
<p>Valid characters are dots, numbers and letters. Dots represent empty space. With numbers and letters, two modes are possible (see <a href="#segsettings">Settings</a>).</p>
<table>
	<tr>
		<th>Mode</th>
		<th>Meaning of numbers and letters</th>
	</tr>
	<tr>
		<td>Normal mode</td>
		<td>Numbers and letters represent respective tiles (see <a href="#segtilesets">Tilesets</a>).</td>
	</tr>
	<tr>
		<td>randominputs</td>
		<td>Numbers and letters represent random tiles, but the same numbers and letters represent same tiles. For example, 1122 would mean two tiles of one random color, and two tiles of another random color.</td>
	</tr>
</table>

<h3 id="segcycle">Cycle</h3>
<pre>
Cycle {
1234567
}
</pre>
(in this example no cycling appears)
<p>Cycle segment defines which shape is current shape replaced with when player presses the "rotate" button.</p>
<p>Cycle segment consists of a single line, which can contain numbers and letters, excluding 0 (zero). Number on the first position denotes cycle shape for the first shape. Number on second position denotes cycle shape for the second shape, etc. If the cycle would be 23415786, if player controls one of the first four shapes, he could exchange them with one another by pressing "rotate". Same goes for last 3 shapes. Shape 5 would not get rotated.</p>

<p>This segment is ignored if inputrotate is set (see <a href="#segsettings">Settings</a>).</p>

<h3 id="seggoals">Goals</h3>
<pre>
Goals {
111
.1.

1.
11
1.

.1.
111

.1
11
.1

22
.2
.2

222
2..

2.
2.
22

..2
222

33
3.
3.

3..
333

.3
.3
33

333
..3

4.
44
.4

.44
44.

.5
55
5.

55.
.55

6666

6
6
6
6

77
77
}
</pre>
(In this example, goals are tetrominos, each in its own color. This variation's goal is to form tetrominos which then disappear.)
<p>When goals are formed, they disappear. If gravity setting is on (see <a href="#segsettings">Settings</a>) other blocks fall in their place.</p>
<p>Goal segment contains definitions of one or several goal shapes, divided by empty line. Definitions are rectangular fields (as in <a href="#segplayfield">Playfield</a> and <a href="#seginput">Input</a>), containing valid characters: dots, numbers, letters, exclamation mark (!) and asterisk (*). Asterisk denotes any non-empty block. Exclamation mark matches also empty blocks, if area to disappear is larger than actual matched blocks.</p>
<table>
	<tr>
		<th>Mode</th>
		<th>Meaning of numbers and letters</th>
	</tr>
	<tr>
		<td>Normal mode</td>
		<td>Numbers and letters represent respective tiles (see <a href="#segtilesets">Tilesets</a>).</td>
	</tr>
	<tr>
		<td>randomgoals</td>
		<td>Numbers and letters represent random tiles, but the same numbers and letters represent same tiles. For example, 1122 would mean two tiles of one random color, and two tiles of another random color.</td>
	</tr>
</table>


<h3 id="seghelp">Help</h3>
<pre>
Help {
factory.html
}
</pre>
<p>Sets file name of the current variation's help file. Default path is variations/</p>

<h3 id="segnext">Next</h3>
<pre>
Next {
}
</pre>
<p>Sets file name of variation which will be loaded when player covers all output tiles (see <a href="#segplayfield">Playfield</a>). Default path is variations/ . File name can have any extension. Files with extension other than .var will not be shown in loader module.

<h3 id="segtilesets">Tilesets</h3>
<pre>
Tilesets {
tiles.bmp
tilesbig.bmp
tetiles2.bmp
tetiles2big.bmp
}
</pre>
<p>This segment contains several names of tile images. Tile images contain tiles which will be rendered on the screen.</p>
<p>In variation file, Tilesets should appear after <a href="#segsettings">Settings</a></p>
<h4>Structure of a tile image</h4>
<p>Tile image is a BMP image. Tiles are squares, arranged in tile image from top to bottom.</p>
<table class="tileimage">
	<tr>
		<th>Tile</th>
		<th>Meaning</th>
		<th>Represented with</th>
	</tr>
	<tr>
		<td><img src="gfx/tilebg.png"></td>
		<td>background</td>
		<td>0 <em>(zero) or</em> . <em>(dot)</em></td>
	</tr>
	<tr>
		<td><img src="gfx/tilesrc.png"></td>
		<td>source</td>
		<td>!</td>
	</tr>
	<tr>
		<td><img src="gfx/tiledest.png"></td>
		<td>destination</td>
		<td>@</td>
	</tr>
	<tr>
		<td><img src="gfx/tile1.png"></td>
		<td>tile 1</td>
		<td>1</td>
	</tr>
	<tr>
		<td><img src="gfx/tile2.png"></td>
		<td>tile 2</td>
		<td>2</td>
	</tr>
	<tr>
		<td><img src="gfx/tile3.png"></td>
		<td>tile 3</td>
		<td>3</td>
	</tr>
	<tr>
		<td><img src="gfx/tile4.png"></td>
		<td>tile 4</td>
		<td>4</td>
	</tr>
	<tr>
		<td><img src="gfx/tile5.png"></td>
		<td>tile 5</td>
		<td>5</td>
	</tr>
	<tr>
		<td><img src="gfx/tile6.png"></td>
		<td>tile 6</td>
		<td>6</td>
	</tr>
	<tr>
		<td><img src="gfx/tile7.png"></td>
		<td>tile 7</td>
		<td>7</td>
	</tr>
</table>


</body>
</html>
